'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

/* eslint-disable no-undefined */

/**
 * @param  {string|Array} item
 * @param  {number} _index
 *
 * @returns {*}
 * @throws {TypeError}
 */
function ponyfill(item, _index) {
  if (typeof item !== 'string' && !Array.isArray(item)) {
    throw new TypeError('Expected a string or array-like item.');
  }

  var index = Math.trunc(_index) || 0;

  if (index < 0) {
    index += item.length;
  }

  if (index < 0 || index >= item.length) {
    return undefined;
  }

  return item[index];
}
var preferNative = function preferNative(item, index) {
  if (typeof item === 'string' && typeof String.prototype.at !== 'undefined' || Array.isArray(item) && Array.prototype.at !== 'undefined') {
    return item.at(index);
  }
  /* istanbul ignore next */


  return ponyfill(item, index);
};

exports.default = ponyfill;
exports.preferNative = preferNative;
//# sourceMappingURL=index.js.map
